<?php

/* 
Plugin Name: Wordpress Thread Comment
Plugin URI: http://blog.2i2j.com/plugins/wordpress-thread-comment
Version: 1.4.3
Author: 偶爱偶家
Description: wp thread comment allow user can reply comment and same comment On display. 允许用户回复某个特定的评论并集中显示相似评论
Author URI: http://blog.2i2j.com/
*/

/*
Translation:

Arabic		M. Bashir Al-Noimi(http://mbnoimi.net/)
*/

/*
ChangeLog:

2008-02-29
			1. 修正重大bug, $deep参数控制出错.
			2. 增加$count参数, 用于控制同一层次中的回复数, 可以用于控制同一层次留言的不同样式.
			3. 修改is_admin()函数, 增加$cap变量, 提高性能.

2008-02-28
			1. 增加global $post in addchildcomment().
			2. 增加is_admin(), is_author()函数, 目前注释掉, 需要时可以直接启用.
			3. 重新设定了default options.

2008-02-27
			1. 修正js中的错误(原commentform位于firstchild时取消回复, commentform消失)
			2. 增加新的preprocess_comment filter, 减少数据库查询一次, 该方法由lot提供(http://blog.net2e.com/).
			3. reply this comment 改成 reply to this comment

2008-02-17
			1. 修正在没有评论回复时出现array_key_exists()函数出错的bug

2008-02-14
			1. 将运行php挪动到str_replace之前.
			2. 增加多层回复功能, 可以自行控制回复深度, 这个要感谢denis(http://fairyfish.net/), 感谢帮我找到这么好的方法.

2007-12-25
			1. 增加time参数, 可以在子评论中显示评论时间.
			2. 增加对php的支持, 可以在子评论样式中直接加入php源码.

2007-11-20
			1. 修正无法通过w3c的xhtml 1.0.

2007-11-14
			1. 增加focus(), 使得在点击回复评论后焦点自动位于comment输入框.

2007-11-13	
			1. 修正在多次点"回复"后, 取消回复无法返回原位置的bug.
			2. 彻底重写wp-thread-comment.js, 大幅度减少代码保证文件小巧, 如果你还觉得不够, 可以删除alert的函数(去除警告即可).
			3. 后台增加email通知内容的设置, 可以设置subject和message.
			4. 解决与wp ajax edit comments 的不兼容问题, 目前可以完全和wp ajax edit comments 协同工作.

2007-11-2
			1. 增加一行曾经遗漏的代码, 现在可以在更新配置后显示更新成功的信息了(一直没有发现这个错误, ft).

2007-11-1
			1. 只在有权评论的时候显示reply按钮;
			2. 修正原先当评论者姓名和日期出现在内容下方的样式中, 被回复者的姓名和日期显示为回复者的姓名和日期的bug;
			3. 增加回复email通知功能, 后台设置三种情况.

2007-10-30
			1. 增加info变量, 用来记录plugin的信息, 保证plugin无论在任何目录都能有效运行.
*/
if(!class_exists('wp_thread_comment')):
class wp_thread_comment{
	var $info = '';
	var $status = '';
	var $message = '';
	var $options = '';
	var $default_options = '';
	var $db_options = 'wpthreadcomment';
	var $formidfromcommentfile = '';
	var $comment_childs = array();
	var $cap = array();

	function wp_thread_comment(){
		$this->init_info();
		$this->formidfromcommentfile = (string) $this->getformidfromcommentfile();

		$defaultopt = array(
			'comment_html' => '<div class="comment-childs chl<?php echo $deep; ?><?php echo $deep%2 ? \' chalt\' : \'\'; ?>" id="comment-[ID]"><p>[author] <em>reply on [date]</em>:</p>[content]</div>',
			'comment_css' => '.editComment, .editableComment, .textComment{ display: inline;}.comment-childs{border: 3px double #999;margin: 5px 2px 4px 4px;padding: 4px 2px 4px 4px;background-color: white;} .chl1{border-color: orange;} .chl2{border-color: lime;} .chl3{border-color: mediumblue;} .chalt {background-color: #E2E2E2;}',
			'comment_formid' => $this->formidfromcommentfile,
			'clean_option' => '',
			'mail_notify' => 'none',
			'mail_subject' => '[blogname] reply inform: [postname]',
			'mail_message' => "<p>[blogname] inform respectfully: your comment on post [postname] now have new reply</p>\r\n<p>your comment:<br />\r\n[pc_content]</p>\r\n<p>reply comment:<br />\r\n[cc_content]</p>\r\n\<p>You can see detail for the comment on this post here:<br />\r\n<a href=\"[commentlink]\">[commentlink]</a></p>\r\n<p><a href=\"[blogurl]\">[blogname]</a> thanks for your attention</p>",
			'comment_deep' => 3
		);

		// Set class property for default options
		$this->default_options = $defaultopt;

		// Get options from WP options
		$optionsFromTable = get_option( $this->db_options );
		if ( !$optionsFromTable ) {
			$this->resetToDefaultOptions();
		}

		// Update default options by getting not empty values from options table
		foreach( (array) $defaultopt as $def_optname => $def_optval ) {
			if(isset($optionsFromTable[$def_optname]) && !empty($optionsFromTable[$def_optname]))
				$defaultopt[$def_optname] = $optionsFromTable[$def_optname];
		}

		// Set the class property and unset no used variable
		$this->options = $defaultopt;
		unset($defaultopt);
		unset($optionsFromTable);

		//add hook
		add_action('init', array(&$this, 'init_textdomain'));
		add_action('admin_menu', array(&$this,'wp_thread_comment_admin'));
		if((string) $this->options['clean_option'] === 'yes')
			add_action('deactivate_'.$this->info['path'].'/'.$this->info['file'], 'deactivate_wp_thread_comment');
		if(!is_admin()){
			add_filter('preprocess_comment', array(&$this,'wp_thread_comment_addreplyid'));
			add_action('comment_post', array(&$this,'wp_thread_comment_mail'));
			add_action('comment_form', array(&$this,'wp_thread_comment_addreplyidformfield'), 1);
			add_action('wp_head', array(&$this,'wp_thread_comment_header'));
			add_filter('comment_text', array(&$this,'wp_thread_comment_addchildcomment'), 2000);
			add_filter('comments_array', array(&$this,'wp_thread_comment_changecomment'),10,2);
		}
	}

	function init_info(){
		$info['file'] = basename(__FILE__);
		$path = basename(str_replace('\\','/',dirname(__FILE__)));
		$info['siteurl'] = get_option('siteurl');
		$info['url'] = $info['siteurl'] . '/wp-content/plugins';
		$info['dir'] = 'wp-content/plugins';
		$info['path'] = '';
		if ( $path != 'plugins' ) {
			$info['url'] .= '/' . $path;
			$info['dir'] .= '/' . $path;
			$info['path'].= $path;
		}
		$this->info = array(
			'siteurl' 			=> $info['siteurl'],
			'url'		=> $info['url'],
			'dir'		=> $info['dir'],
			'path'		=> $info['path'],
			'file'		=> $info['file']
		);
		unset($info);
	}
	function init_textdomain() {
		load_plugin_textdomain('wp-thread-comment',$this->info['dir']);
	}

	function deactivate_wp_thread_comment(){
		delete_option($this->db_options);
		return true;
	}

	function resetToDefaultOptions() {
		update_option($this->db_options, $this->default_options);
		$this->options = $this->default_options;
	}

	function getformidfromcommentfile(){

		$commentfile = ABSPATH.'wp-content/themes/'.get_option('stylesheet').'/comments.php';
	
		if(!is_file($commentfile))
			$commentfile = ABSPATH.'wp-content/themes/default/comments.php';
		if(is_file($commentfile)){
			$context = file_get_contents($commentfile);

			if(!empty($context)){
				if(preg_match('/<(form.*?wp-comments-post\\.php.*?)>/ius', $context, $match)){
					$context = $match[1];

					if(preg_match('/id\s*?=\s*?"(.*?)"/ius', $context, $match)){
						unset($commentfile, $context);
						return $match[1];
					}
				}
			}
		}
		unset($commentfile, $context, $match);
		return '';
	}

	function wp_thread_comment_changecomment($comments){
		foreach ($comments as $i => $value) {
			if($value->comment_parent > 0){
				$this->comment_childs[$value->comment_parent][] = $value;
				unset($comments[$i]);
			}
		}
		return $comments;
	}

	function wp_thread_comment_addreplyid($commentdata){
		$commentdata['comment_parent'] = mysql_escape_string($_POST['comment_reply_ID']);
		return $commentdata;
	}
	
/*	function btc_add_reply_id($id){
		global $wpdb;

		$reply_id = mysql_escape_string($_POST['comment_reply_ID']);
		//$q = $wpdb->query("UPDATE {$wpdb->comments} SET comment_parent='$reply_id' WHERE comment_ID='$id'");

		if($this->options['mail_notify'] == 'admin' || $this->options['mail_notify'] == 'everyone'){

			$comment_post_id = mysql_escape_string($_POST['comment_post_ID']);
			$this->mail_notify($id,$reply_id,$comment_post_id);
		}
		unset($comment_post_id,$reply_id);
		return $id;
	}*/

	function wp_thread_comment_mail($id){

		if($this->options['mail_notify'] == 'admin' || $this->options['mail_notify'] == 'everyone'){

			$this->mail_notify($id,mysql_escape_string($_POST['comment_reply_ID']),mysql_escape_string($_POST['comment_post_ID']));
		}

		return $id;

	}
	
	function mail_notify($id,$parent_id,$comment_post_id){
		global $wpdb, $user_ID, $userdata, $user_identity;

		if($this->options['mail_notify'] == 'admin'){
			$cap = $wpdb->prefix . 'capabilities';
			$post = get_post($comment_post_id);
			if((strtolower((string) array_shift(array_keys((array)($userdata->$cap)))) !== 'administrator') && ((int)$post->post_author !== (int)$user_ID)){
				return;
			}
		}
		
		$parent_email = $wpdb->get_var("SELECT comment_author_email FROM {$wpdb->comments} WHERE comment_ID='$parent_id'");

		if(empty($parent_email) || !is_email($parent_email)){
			return;
		}

		$pc = get_comment($parent_id);
		$cc = get_comment($id);

		$mail_subject = $this->options['mail_subject'];
		$mail_subject = str_replace('[blogname]', get_option('blogname'), $mail_subject);
		$mail_subject = str_replace('[postname]', $post->post_title, $mail_subject);

		$mail_message = $this->options['mail_message'];
		$mail_message = str_replace('[pc_date]', $pc->comment_date, $mail_message);
		$mail_message = str_replace('[pc_content]', $pc->comment_content, $mail_message);
		
		$mail_message = str_replace('[cc_author]', $cc->comment_author, $mail_message);
		$mail_message = str_replace('[cc_date]', $cc->comment_date, $mail_message);
		$mail_message = str_replace('[cc_url]', $cc->comment_url, $mail_message);
		$mail_message = str_replace('[cc_content]', $cc->comment_content, $mail_message);

		$mail_message = str_replace('[blogname]', get_option('blogname'), $mail_message);
		$mail_message = str_replace('[blogurl]', get_option('siteurl'), $mail_message);
		$mail_message = str_replace('[postname]', $post->post_title, $mail_message);
		$mail_message = str_replace('[commentlink]', get_permalink($comment_post_id)."#comment-{$parent_id}", $mail_message);

		$wp_email = 'wordpress@' . preg_replace('#^www\.#', '', strtolower($_SERVER['SERVER_NAME']));
		$from = "From: \"".get_option('blogname')."\" <$wp_email>";

		$mail_headers = "$from\nContent-Type: text/html; charset=" . get_option('blog_charset') . "\n";

		unset($wp_email, $from);

		$mail_message = apply_filters('comment_notification_text', $mail_message, $id);
		$mail_subject = apply_filters('comment_notification_subject', $mail_subject, $id);
		$mail_headers = apply_filters('comment_notification_headers', $mail_headers, $id);

		@wp_mail($parent_email, $mail_subject, $mail_message, $mail_headers);
		unset($mail_subject,$parent_email,$mail_message);
		
		return;
	}

	function wp_thread_comment_addreplyidformfield(){
		echo "<input type='hidden' id='comment_reply_ID' name='comment_reply_ID' value='0' />";
		echo '<div id="reroot" style="display:none;"><small><a href="javascript:void(0)" onclick="movecfm();" style="color:red;">' . __('click to cancel reply','wp-thread-comment') . '</a></small></div>';
	}

//此部分为is_admin()和is_author()函数, 需要者可以自行启用
/*	function get_usermeta($meta_key, $meta_value = ''){
		global $wpdb;

		if (empty($meta_key))
			return false;

		$meta_key = preg_replace('|[^a-z0-9_]|i', '', $meta_key);

		if (!empty($meta_value)){
			$metas = $wpdb->get_col("SELECT user_id FROM $wpdb->usermeta WHERE meta_key = '$meta_key' AND meta_value LIKE '$meta_value'");
		}else{
			$metas = $wpdb->get_col("SELECT user_id FROM $wpdb->usermeta WHERE meta_key = '$meta_key'");
		}

		if (empty($metas)){
			return array();
		}

		return $metas;
	}

	function is_admin($user_id = 0){
		global $wpdb;

		$user_id = (int) $user_id;

		if($user_id == 0)
			return false;

//		$cap = get_usermeta($user_id,$wpdb->prefix . 'capabilities');
//		if( is_array($cap) && ((int)$cap['administrator'] === 1) ){
//			return true;
//		}elseif(strpos($cap,'administrator')){
//			return true;
//		}else{}
//		return false;

		if(count($this->cap) < 1)
			$this->cap = $this->get_usermeta($wpdb->prefix . 'capabilities', '%administrator%');

		if(in_array($user_id,$this->cap))
			return true;

		return false;
		
	}

	
	function is_author($user_id = 0){
		global $post;

		$user_id = (int) $user_id;
		
		if($user_id == 0)
			return false;

		if((int)$post->post_author === $user_id)
			return true;

		return false;
	}*/
//到这里就结束了.

	function wp_thread_comment_addchildcomment($text){
		global $post, $comment, $user_ID, $userdata;
		static $deep = 0;

		if($comment->comment_parent === 0)
			$deep = 0;
		
		if( (string) $comment->comment_type === 'pingback' || (string) $comment->comment_type === 'trackback')
			return $text;

		$orgcomment = $comment;

		if( (!get_option('comment_registration') || (get_option('comment_registration') && $user_ID)) && $deep < (int) $this->options['comment_deep'] ){
			$text = $text. '<p>[<a href="javascript:void(0)" onclick="movecfm(' . get_comment_ID() . ');">'. __('reply to this comment','wp-thread-comment') . '</a>]</p>';
		}

		if(array_key_exists($comment->comment_ID, $this->comment_childs)){

			$deep++;

			$id_temp = $comment->comment_ID;

			$count = 0;
			foreach($this->comment_childs[$id_temp] as $comment){

				$count++;

				$p = $this->options['comment_html'];

				ob_start();
				ob_clean();
				//$p = str_replace('<'.'?php','<'.'?',$p);
				eval('?'.'>'.$p);
				$p = ob_get_contents();
				ob_end_clean();
								
				$p = str_replace('[ID]', get_comment_ID(), $p);
				$p = str_replace('[author]', get_comment_author_link(), $p);
				$p = str_replace('[date]', get_comment_date(), $p);
				$p = str_replace('[time]', get_comment_time(), $p);
				
				if(strpos($p,'[content]')){
					ob_start();
					ob_clean();
					comment_text();
					$content_text = ob_get_contents();
					ob_end_clean();
					$p = str_replace('[content]', $content_text, $p);
				}

				$text .= $p;
			}
			unset($this->comment_childs[$id_temp]);

			$deep--;
		}
		$comment = $orgcomment;
		unset($orgcomment);
		if($deep < 0) $deep = 0;
		return $text;
	}

	function wp_thread_comment_header(){


		$threadhead = "<script type=\"text/javascript\">\nvar vcommentform = \"". $this->options['comment_formid'] . "\";\n</script>\n";

		$threadhead.= "<script type=\"text/javascript\" src=\"". $this->info['url'] . "/wp-thread-comment.js\"></script>\n";

		echo $threadhead;
		echo '<style type="text/css"><!--' . $this->options['comment_css'] . '--></style>';

		unset($threadhead);
	}

	function wp_thread_comment_admin(){
		add_options_page(__('WP Thread Comment Option','wp-thread-comment'), __('WP Thread Comment','wp-thread-comment'), 5, __FILE__, array(&$this,'wp_thread_comment_options_page'));
	}

	function displayMessage() {
		if ( $this->message != '') {
			$message = $this->message;
			$status = $this->status;
			$this->message = $this->status = ''; // Reset
		}

		if ( $message ) {
?>
			<div id="message" class="<?php echo ($status != '') ? $status :'updated'; ?> fade">
				<p><strong><?php echo $message; ?></strong></p>
			</div>
<?php	
		}
		unset($message,$status);
	}

	function wp_thread_comment_options_page(){

		if ( isset($_POST['updateoptions']) ) {
			foreach((array) $this->options as $key => $oldvalue) {
				$newval = ( isset($_POST[$key]) && !empty($_POST[$key]) ) ? stripslashes($_POST[$key]) : $this->default_options[$key];
				//if ($newval != $oldvalue) {
					$this->options[$key] = $newval;
				//}
			}
			update_option($this->db_options, $this->options);
			$this->message = __('Options saved','wp-thread-comment');
			$this->status = 'updated';
		} elseif ( isset($_POST['reset_options']) ){
			update_option( $this->db_options, $this->default_options );
			$this->options = $this->default_options;
			$this->message = __('resetted to default options!','wp-thread-comment');
		}
		$this->displayMessage();
?>
<div class="wrap">
	<style type="text/css">
		div.clearing{border-top:1px solid #2580B2 !important;clear:both;}
	</style>

	<h2>WP Thread Comment</h2>
	<form method="post" action="">
		<fieldset name="wp_basic_options"  class="options">
		<p>
			<strong><?php _e('Edit Comment HTML','wp-thread-comment'); ?></strong>
			<br /><br />
			<textarea style="font-size: 90%" name="comment_html" id="comment_html" cols="100%" rows="3" ><?php echo htmlspecialchars(stripslashes($this->options['comment_html'])); ?></textarea>
			<br />
			<small><?php _e('Use HTML and PHP. You can use <strong>[ID]</strong> for comment ID, <strong>[author]</strong> for comment author, <strong>[date]</strong> for comment date, <strong>[time]</strong> for comment time and <strong>[content]</strong> for comment content.','wp-thread-comment'); ?></small>
		</p>
		<div class="clearing"></div>
		<p>
			<strong><?php _e('Edit Comment CSS','wp-thread-comment'); ?></strong>
			<br /><br />
			<textarea style="font-size: 90%" name="comment_css" id="comment_css" cols="100%" rows="3" ><?php echo htmlspecialchars(stripslashes($this->options['comment_css'])); ?></textarea>
			<br />
			<small><?php _e('Use CSS only, HTML and PHP cannot be used.','wp-thread-comment'); ?></small>
		</p>
		<div class="clearing"></div>
		<p>
			<strong><?php _e('Edit Comment Form ID','wp-thread-comment'); ?></strong>
			<br /><br />
			<label>Comment Form ID:</label>
			<input type="text" name="comment_formid" id="comment_formid" value="<?php echo $this->options['comment_formid']; ?>" size="15" />
			<br />
			<small><?php _e('Input your comment form id (that in comments.php which in your themes where you post comment). if you cant determined, you should leave it intact, wp-thread-comment can automatic detection.','wp-thread-comment'); ?></small>
			<br />
			<small><?php echo sprintf(__('Now detected comment Form ID is [<strong>%s</strong>] , you can copy this ID to input box above.','wp-thread-comment'), $this->formidfromcommentfile); ?></small>
		</p>
		<div class="clearing"></div>
		<p>
			<strong><?php _e('Edit Thread Comment Deepth','wp-thread-comment'); ?></strong>
			<br /><br />
			<label><?php _e('Thread Comment Deepth:','wp-thread-comment'); ?></label>
			<input type="text" name="comment_deep" id="comment_deep" value="<?php echo $this->options['comment_deep']; ?>" size="2" />
			<br />
			<small><?php _e('Input thread comment deepth that you want comment author can reply.','wp-thread-comment'); ?></small>
		</p>

		<div class="clearing"></div>
		<p>
			<strong><?php _e('Mail Parent Comment when reply:','wp-thread-comment'); ?></strong>
			<br /><br />
			<input type="radio" name="mail_notify" id="do_none" value="none" <?php if ($this->options['mail_notify'] == 'none') { ?> checked="checked"<?php } ?>/><label><?php _e('not mail','wp-thread-comment'); ?></label>
			<br />
			<input type="radio" name="mail_notify" id="do_admin" value="admin" <?php if ($this->options['mail_notify'] == 'admin') { ?> checked="checked"<?php } ?>/><label><?php _e('mail when admin or author reply','wp-thread-comment'); ?></label>
			<br />
			<input type="radio" name="mail_notify" id="do_everyone" value="everyone" <?php if ($this->options['mail_notify'] == 'everyone') { ?> checked="checked"<?php } ?>/><label><?php _e('mail when everyone reply','wp-thread-comment'); ?></label>
			<br />
		</p>
		<div class="clearing"></div>
		<p>
			<strong><?php _e('Edit Email Subject','wp-thread-comment'); ?></strong>
			<br /><br />
			<input type="text" name="mail_subject" id="mail_subject" value="<?php echo $this->options['mail_subject']; ?>" size="80" />
			<br />
			<small><?php _e('Use TEXT only. You can use <strong>[blogname]</strong> for blog name and <strong>[postname]</strong> for comment post name','wp-thread-comment'); ?></small>
			<br />
		</p>
		<div class="clearing"></div>
		<p>
			<strong><?php _e('Edit Email Message','wp-thread-comment'); ?></strong>
			<br /><br />
			<textarea style="font-size: 90%" name="mail_message" id="mail_message" cols="100%" rows="10" ><?php echo htmlspecialchars(stripslashes($this->options['mail_message'])); ?></textarea>
			<br />
			<small><?php _e('Use HTML only. You can use <strong>[pc_date]</strong> for parent comment date, <strong>[pc_content]</strong> for parent comment content, <strong>[cc_author]</strong> for child comment author, <strong>[cc_date]</strong> for child comment date, <strong>[cc_url]</strong> for child comment author url, <strong>[cc_content]</strong> for child comment content, <strong>[commentlink]</strong> for parent comment link, <strong>[blogname]</strong> for blog name, <strong>[blogurl]</strong> for blog url and <strong>[postname]</strong> for post name.','wp-thread-comment'); ?></small>
		</p>
		<div class="clearing"></div>
		<p>
			<strong><?php _e('Configuration deal with deactivate','wp-thread-comment'); ?></strong>
			<br /><br />
			<label><?php _e('Clean Configuration after deactivate:','wp-thread-comment'); ?></label>
			<input type="checkbox" name="clean_option" id="clean_option" value="yes" <?php if ($this->options['clean_option'] == 'yes') { ?> checked="checked"<?php } ?>/>
			<br />
			<small><?php _e('check box if you want to clean configuration after deactivate wp-thread-comment','wp-thread-comment'); ?></small>
		</p>
		<p class="submit">
			<input type="submit" name="updateoptions" value="<?php _e('Update Options','wp-thread-comment'); ?> &raquo;" />
			<input type="submit" name="reset_options" onclick="return confirm('<?php _e('Do you really want to restore the default options?','wp-thread-comment'); ?>');" value="<?php _e('Reset Options','wp-thread-comment'); ?>" />
		</p>
		</fieldset>
	</form>
</div>
<?php
	}
}
endif;

if (!(isset($_POST['SaveCommentId']) && isset($_POST['SaveContent']) && isset($_POST['_wpnonce']))){
	$new_wp_thread_comment = new wp_thread_comment();
}
?>